// MAT assignment2: 2D Data visualization 
// Author: Ming-Yu Lin
// Time: 02/04/2018

Table table;
int rows, cols;
float radius;
int dataMatrix[][];
float maxValues[];
float minValues[];
String[] titles;
int year;
boolean[] yearChecked;
String[] years;
color[] colors;
int constHorizontalMargin = 280;
int constVerticalMargin = 140;
float[] coordinate_x;
float coordinate_y;
float cellWidth;
float cellHeight;


void setup() {
  size(1920, 1400);
  table = loadTable("data/harryPotter.csv");
  rows = table.getRowCount();
  cols = table.getColumnCount();
  dataMatrix = new int[rows-1][cols-2];
  titles = new String[rows-1];
  yearChecked = new boolean[cols-2];
  maxValues = new float[cols-2];
  minValues = new float[cols-2];
  years = new String[cols-2];
  colors = new color[cols-2];
  colors[0] = #FF0000;
  colors[1] = #FF7F00;
  colors[2] = #FFFF00;
  colors[3] = #00FF00;
  colors[4] = #0000FF;
  colors[5] = #4B0082;
  colors[6] = #9400D3;
  // Load data to dataMatrix
  for (int i=0; i < rows - 1; ++i){
    for(int j=0; j < cols - 2; ++j){
      dataMatrix[i][j] = table.getInt(i+1, j+2);
      if (dataMatrix[i][j] > maxValues[i]){
        maxValues[i] = dataMatrix[i][j];
      }
      if (i == 0) {
         years[j] = table.getString(i,j+2);
         yearChecked[j] = false;
      }
    }
    titles[i] = table.getString(i+1,0).substring(21);
    titles[i] = titles[i].substring(0,1).toUpperCase() + titles[i].substring(1);
  }

  for(int i=0; i<dataMatrix.length; i++){
    minValues[i] = maxValues[i];
    for(int j=0; j<dataMatrix[0].length; j++){
      if(dataMatrix[i][j] < minValues[i]){
        minValues[i] = dataMatrix[i][j];
      }
    }
  }
  noLoop();
}

void draw() {
  background(0);
  int textOffset = 40;
  coordinate_x = new float[cols-2];
  coordinate_y = height - constVerticalMargin;
  cellWidth = (width - constHorizontalMargin - 28)/(cols - 2);
  cellHeight = (height - constVerticalMargin*2 - textOffset*2 - 42) / (rows - 1);
  
  // Harry Potter
  textSize(50);
  textAlign(LEFT);
  fill(255);
  text("Harry Potter",32,70);
  
  // button year at the bottom
  for(int i = 0; i < cols-2; i++){
    textSize(32);
    fill(107);
    text(years[i], cellWidth*i+constHorizontalMargin + 40, height - constVerticalMargin);
    coordinate_x[i] = cellWidth*i+constHorizontalMargin + 40;
  }

  // for title text
  for(int i =0; i < rows-1; i++) {
    textSize(30);
    textAlign(LEFT);
    text(titles[i], 32, cellHeight*i+constVerticalMargin+10);
  }
  
  // Line for base
  strokeWeight(10);
  stroke(107);
  line(constHorizontalMargin, height- textOffset * 2 - 32 - constVerticalMargin, width - 40, height - textOffset * 2 - 32 - constVerticalMargin);
  if(any(yearChecked) == -1){
    // draw every year
    for(int i=0; i<dataMatrix.length; i++){
      for(int j=0; j<dataMatrix[0].length; j++){
        float greyScale = map(dataMatrix[i][j], minValues[i], maxValues[i], 50, 240);
        float rectWidth = dataMatrix[i][j]/12 + 1;
        strokeWeight(1);
        stroke(colors[i]);
        fill(colors[i],greyScale);
        rectMode(CENTER);
        rect(cellWidth*j + constHorizontalMargin+68,
             cellHeight*i+ constVerticalMargin,
             rectWidth,rectWidth);
      }
    }
  } else {
    // draw bar plot for each year
    int j = any(yearChecked);
    textSize(40);
    text(years[j],coordinate_x[5],50);
    for(int i=0; i<dataMatrix.length; i++){
      float greyScale = map(dataMatrix[i][j], minValues[i], maxValues[i], 50, 240);
      float rectWidth = 50.0;
      float rectLength = dataMatrix[i][j];
      strokeWeight(1);
      stroke(colors[i]);
      fill(colors[i],greyScale);
      rect(coordinate_x[0] + rectLength*0.4 + 40,
           (height - constVerticalMargin*2 - textOffset*2 - 42)/(rows-1)*i+ constVerticalMargin,
           rectLength *0.8 ,rectWidth);
      fill(107);
      textSize(28);
      textAlign(RIGHT);
      text(dataMatrix[i][j],coordinate_x[11],cellHeight*i+constVerticalMargin+10);
    }
  }
}

void mousePressed(){
  boolean onYear = false;
  for(int i = 0; i < cols-2; i++){
    if (mouseX > coordinate_x[i] - cellWidth/2 && mouseX < coordinate_x[i] + cellWidth/2 &&
        mouseY > coordinate_y +40 - cellHeight/2 && mouseY < coordinate_y + 32 + cellWidth/2){
      yearsChecked(yearChecked,i);
      onYear = true;
      break;
    }
  }
  if (!onYear){
    yearsChecked(yearChecked,12);
  }
  redraw();
}